<?php

namespace HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros;

use HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros\Registro0000;

class Registro0050 extends Registro0000 {

    private $_nome;
    private $_cnpj;
    private $_cpf;
    private $_crc;
    private $_dtIni;
    private $_dtFim;
    private $_end;
    private $_num;
    private $_compl;
    private $_bairro;
    private $_cep;
    private $_uf;
    private $_cp = null;
    private $_cepCp = null;
    private $_fone;
    private $_fax;
    private $_email;

    public function geraRegistro0050(){
        $this->_geraRegistro(self::REGISTRO_0050);
    }

    private function _geraRegistro($tpRegistro){
        // Ordem 1
        $this->atribuiDadoManad($tpRegistro);
        // Ordem 2
        $this->atribuiDadoManad($this->_nome);
        // Ordem 3
        $this->atribuiDadoManad($this->_cnpj);
        // Ordem 4
        $this->atribuiDadoManad($this->_cpf);
        // Ordem 5
        $this->atribuiDadoManad($this->_crc);
        // Ordem 6
        $this->atribuiDadoManad($this->_dtIni);
        // Ordem 7
        $this->atribuiDadoManad($this->_dtFim);
        // Ordem 8
        $this->atribuiDadoManad($this->_end);
        // Ordem 9
        $this->atribuiDadoManad($this->_num);
        // Ordem 10
        $this->atribuiDadoManad($this->_compl);
        // Ordem 11
        $this->atribuiDadoManad($this->_bairro);
        // Ordem 12
        $this->atribuiDadoManad($this->_cep);
        // Ordem 13
        $this->atribuiDadoManad($this->_uf);
        // Ordem 14
        $this->atribuiDadoManad($this->_cp);
        // Ordem 15
        $this->atribuiDadoManad($this->_cepCp);
        // Ordem 16
        $this->atribuiDadoManad($this->_fone);
        // Ordem 17
        $this->atribuiDadoManad($this->_fax);
        // Ordem 18
        $this->atribuiDadoManad($this->_email, true);
    }
    
    public function setNome($nome){
        $this->_nome = $nome;
    }
    public function setCnpj($cnpj){
        $this->_cnpj = $cnpj;
    }
    public function setCpf($cpf){
        $this->_cpf = $cpf;
    }
    public function setCrc($crc){
        $this->_crc = $crc;
    }
    public function setEnd($end){
        $this->_end = $end;
    }
    public function setNum($num){
        $this->_num = $num;
    }
    public function setCompl($compl){
        $this->_compl = $compl;
    }
    public function setBairro($bairro){
        $this->_bairro = $bairro;
    }
    public function setCep($cep){
        $this->_cep = $cep;
    }
    public function setUf($uf){
        $this->_uf = $uf;
    }
    public function setCp($cp){
        $this->_cp = $cp;
    }
    public function setDtIni($dtIni){
        $this->_dtIni = $dtIni;
    }
    public function setDtFim($dtFim){
        $this->_dtFim = $dtFim;
    }
    public function setCepCp($cepCp){
        $this->_cepCp = $cepCp;
    }
    public function setFone($fone){
        $this->_fone = $fone;
    }
    public function setFax($fax){
        $this->_fax = $fax;
    }
    public function setEmail($email){
        $this->_email = $email;
    }
}