<?php
    
namespace HCM\FPA\ObrigacaoLegal\Manad;

class QueryManad {
    public function __construct($entityManager, $hcmParameters){
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function get_reg0000($params){
        $sql = $this->entityManager->getConnection()->prepare(<<<SQL
            SELECT SUBSTR(EH.NMRAZSOCESTRUT, 1, 255) NOMEEMPRESARIAL,
                    PN.CDTIPOINSCRICAO TPINSC,
                    SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT, '.', ''), '/', ''), '-', ''), 1, 14) CDCNPJ,
                    SUBSTR(REPLACE(REPLACE(EH.CDCEIESTRUT,'.',''),'-',''), 1, 12) CDCEI,
                    M.SGESTADO CDUF,
                    M.CDMUNICIBGE CDMUN
            FROM ESTRUTURAM EM
            JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                AND EH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                                FROM (SELECT DTMESCOMPETENC
                                                        FROM ESTRUTURAH H1
                                                        WHERE H1.NRORG = EH.NRORG
                                                            AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                            AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                            ORDER BY DTMESCOMPETENC DESC)
                                                WHERE ROWNUM = 1)
            JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                                AND PN.NRORG = EH.NRORG
            JOIN ENDERECOPARC E ON E.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
                                AND E.NRORG = PN.NRORG
                                AND E.CDTIPOENDERECO = 'PRINCIPAL'
            JOIN MUNICIPIO M ON E.CDPAIS = M.CDPAIS
                            AND E.SGESTADO = M.SGESTADO
                            AND E.CDMUNICIPIO = M.CDMUNICIPIO
            WHERE EM.NRORG = :P_NRORG
              AND EM.NRESTRUTURAM = :P_ESTRUTURARESPONSAVEL
SQL
);
        $sql->execute($params);
        return $sql->fetch();
    }

    public function get_reg0050($params){    
        $sql = $this->entityManager->getConnection()->prepare(<<<SQL
            SELECT PE.NRPESSOA,
                    SUBSTR(PEH.NMPESSOA, 1, 255) NMNOMERESP,
                    CASE
                        WHEN PNEST.CDTIPOINSCRICAO = 'CNPJ' THEN
                            SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT, '.', ''), '/', ''), '-', ''), 1, 14)
                        ELSE NULL
                    END CDCNPJ,
                    SUBSTR(REPLACE(REPLACE(PEH.NRCPFPESSOA,'.',''),'-',''), 1, 11) CDCPF,
                    SUBSTR(PEH.NRINSCRCONSREG, 1, 11) CDCRC,
                    SUBSTR(TRIM(UPPER(LG.DSLOGRADOURO || ' ' || E.DSENDERECO)), 1, 255) DSEND,
                    E.NRIMOVELENDERECO NRNUMEND,
                    TRIM(E.DSCOMPLEENDERECO) DSCOMP,
                    TRIM(E.NMBAIRROENDERECO) DSBAIRRO,
                    SUBSTR(REPLACE(REPLACE(E.NRCEPENDERECO,'.',''),'-',''), 1, 8) CDCEP,
                    EST.SGESTADO,
                    SUBSTR( TRIM( LEADING '0' FROM REPLACE( TRANSLATE( TEL.CDPREFIXCOMUPARC, '() ', '-'), '-', '') ), 1, 2 ) NRDDD,
                    SUBSTR(                        REPLACE( TRANSLATE( TEL.CDCOMUNICAPARC,   '() ', '-'), '-', '')  , 1, 9 ) NRTELEFONE,
                    SUBSTR( TRIM( LEADING '0' FROM REPLACE( TRANSLATE( FAX.CDPREFIXCOMUPARC, '() ', '-'), '-', '') ), 1, 2 ) NRDDDFAX,
                    SUBSTR( REPLACE( TRANSLATE( FAX.CDCOMUNICAPARC, '() ', '-'), '-', ''), 1, 9 )  NRFAX,
                    SUBSTR( EMA.CDCOMUNICAPARC, 1, 50 ) NMEMAIL
            FROM GPE_PESSOA PE
            LEFT JOIN GPE_PESSOAH PEH ON PEH.NRORG        = PE.NRORG
                                    AND PEH.NRPESSOA     = PE.NRPESSOA
            LEFT JOIN ESTRUTURAM EM ON EM.NRESTRUTURAM = :P_ESTRUTURARESPONSAVEL
                                    AND EM.NRORG = :P_NRORG
            LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                AND EH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                                            FROM (SELECT DTMESCOMPETENC
                                                                    FROM ESTRUTURAH H1
                                                                WHERE H1.NRORG = EH.NRORG
                                                                    AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                                    AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                    ORDER BY DTMESCOMPETENC DESC)
                                                            WHERE ROWNUM = 1)
            LEFT JOIN PARCNEGOCIO PNEST ON PNEST.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                                        AND PNEST.NRORG = EH.NRORG
            LEFT JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                    AND PN.NRORG = PE.NRORG
            LEFT JOIN ENDERECOPARC E ON E.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
                                    AND E.NRORG = PN.NRORG
                                    AND E.CDTIPOENDERECO = 'PRINCIPAL'
            LEFT JOIN LOGRADOURO LG ON LG.CDLOGRADOURO = E.CDLOGRADOURO
                                    AND ( LG.NRORG = E.NRORG
                                    OR LG.NRORG = :P_NRORGPADRAO)
            LEFT JOIN PAIS ON PAIS.CDPAIS = E.CDPAIS
            LEFT JOIN ESTADO EST ON EST.SGESTADO = E.SGESTADO
                                AND PAIS.CDPAIS = EST.CDPAIS
            LEFT JOIN COMUNICAPARC TEL ON TEL.NRORG         = PE.NRORG
                                    AND TEL.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                    AND TEL.CDFORMACOMU   = 1 
            LEFT JOIN COMUNICAPARC FAX ON FAX.NRORG         = PE.NRORG
                                    AND FAX.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                    AND FAX.CDFORMACOMU   = 10 
            LEFT JOIN COMUNICAPARC EMA ON EMA.NRORG         = PE.NRORG
                                    AND EMA.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                    AND EMA.CDFORMACOMU   = 5
            WHERE PE.NRORG    = :P_NRORG
            AND PE.NRPESSOA = :P_NRPESSRESPONSA
            AND ( PEH.DTMESCOMPETENC = ( SELECT DTMESCOMPETENC
                                            FROM (SELECT DTMESCOMPETENC
                                                    FROM GPE_PESSOAH
                                                    WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                        AND NRORG    = PE.NRORG
                                                        AND NRPESSOA = PE.NRPESSOA
                                                        ORDER BY DTMESCOMPETENC DESC)
                                            WHERE ROWNUM = 1)
                    OR PEH.DTMESCOMPETENC IS NULL )
            AND ( TEL.NRCOMUNICAPARC = ( SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC
                                            WHERE NRORG         = PE.NRORG
                                            AND NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                            AND CDFORMACOMU   = 1 )
                    OR TEL.NRCOMUNICAPARC IS NULL )
            AND ( FAX.NRCOMUNICAPARC = ( SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC
                                            WHERE NRORG         = PE.NRORG
                                            AND NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                            AND CDFORMACOMU   = 10 )
                    OR FAX.NRCOMUNICAPARC IS NULL )
            
            AND ( EMA.NRCOMUNICAPARC = ( SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC
                                            WHERE NRORG         = PE.NRORG
                                            AND NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                            AND CDFORMACOMU   = 5 )
                    OR EMA.NRCOMUNICAPARC IS NULL )
SQL
);
        $sql->execute($params);
        return $sql->fetch();
    }

    public function get_reg0100($params){    

        $sql = $this->entityManager->getConnection()->prepare(<<<SQL
            SELECT PE.NRPESSOA,
                SUBSTR(PEH.NMPESSOA, 1, 255) NMNOMERESP,
                VH.NRCARGO CDCARGO,
                CARGO.NMOCUPACAOH  NMCARGO,
                CASE
                        WHEN PNEST.CDTIPOINSCRICAO = 'CNPJ' THEN
                            SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT, '.', ''), '/', ''), '-', ''), 1, 14)
                        ELSE NULL
                END CDCNPJ,
                SUBSTR(REPLACE(REPLACE(PEH.NRCPFPESSOA,'.',''),'-',''), 1, 11) CDCPF,
                SUBSTR( TRIM( LEADING '0' FROM REPLACE( TRANSLATE( TEL.CDPREFIXCOMUPARC, '() ', '-'), '-', '') ), 1, 2 ) NRDDD,
                SUBSTR(                        REPLACE( TRANSLATE( TEL.CDCOMUNICAPARC,   '() ', '-'), '-', '')  , 1, 9 ) NRTELEFONE,
                SUBSTR( TRIM( LEADING '0' FROM REPLACE( TRANSLATE( FAX.CDPREFIXCOMUPARC, '() ', '-'), '-', '') ), 1, 2 ) NRDDDFAX,
                SUBSTR( REPLACE( TRANSLATE( FAX.CDCOMUNICAPARC, '() ', '-'), '-', ''), 1, 9 )  NRFAX,
                SUBSTR( EMA.CDCOMUNICAPARC, 1, 50 ) NMEMAIL
            FROM GPE_PESSOA PE
            LEFT JOIN GPE_PESSOAH PEH ON PEH.NRORG        = PE.NRORG
                                    AND PEH.NRPESSOA     = PE.NRPESSOA
            LEFT JOIN ESTRUTURAM EM ON EM.NRESTRUTURAM = :P_ESTRUTURARESPONSAVEL
                                AND EM.NRORG = :P_NRORG
            LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                AND EH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                                        FROM (SELECT DTMESCOMPETENC
                                                                FROM ESTRUTURAH H1
                                                                WHERE H1.NRORG = EH.NRORG
                                                                    AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                                    AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                    ORDER BY DTMESCOMPETENC DESC)
                                                        WHERE ROWNUM = 1)
            LEFT JOIN GPE_VINCULOM VM ON VM.NRPESSOA = PE.NRPESSOA
                                    AND VM.NRORG = PE.NRORG
            LEFT JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                                    AND VH.NRORG = VM.NRORG
                                    AND VH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                                                FROM (SELECT VHH.DTMESCOMPETENC
                                                                        FROM GPE_VINCULOH VHH
                                                                    WHERE VHH.NRORG = VH.NRORG
                                                                        AND VHH.NRVINCULOM = VH.NRVINCULOM
                                                                        AND VHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                        ORDER BY DTMESCOMPETENC DESC)
                                                            WHERE ROWNUM = 1)
            LEFT JOIN GPE_OCUPACAOH CARGO ON CARGO.NROCUPACAOM = VH.NRCARGO
                                        AND CARGO.NRORG = VH.NRORG
                                        AND CARGO.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                                                FROM (SELECT CARGOH.DTMESCOMPETENC
                                                                        FROM GPE_OCUPACAOH CARGOH
                                                                        WHERE CARGOH.NRORG = CARGO.NRORG
                                                                        AND CARGOH.NROCUPACAOM = CARGO.NROCUPACAOM
                                                                        AND CARGOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                        ORDER BY DTMESCOMPETENC DESC)
                                                            WHERE ROWNUM = 1)
            LEFT JOIN PARCNEGOCIO PNEST ON PNEST.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                                    AND PNEST.NRORG = EH.NRORG
            LEFT JOIN COMUNICAPARC TEL ON TEL.NRORG         = PE.NRORG
                                    AND TEL.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                    AND TEL.CDFORMACOMU   = 1 
            LEFT JOIN COMUNICAPARC FAX ON FAX.NRORG         = PE.NRORG
                                    AND FAX.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                    AND FAX.CDFORMACOMU   = 10 
            LEFT JOIN COMUNICAPARC EMA ON EMA.NRORG         = PE.NRORG
                                    AND EMA.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                    AND EMA.CDFORMACOMU   = 5
            WHERE PE.NRORG    = :P_NRORG
            AND PE.NRPESSOA = :P_NRPESSRESPONSA
            AND ( PEH.DTMESCOMPETENC = ( SELECT DTMESCOMPETENC
                                            FROM (SELECT DTMESCOMPETENC
                                                    FROM GPE_PESSOAH
                                                    WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                    AND NRORG    = PE.NRORG
                                                    AND NRPESSOA = PE.NRPESSOA
                                                    ORDER BY DTMESCOMPETENC DESC)
                                            WHERE ROWNUM = 1)
                    OR PEH.DTMESCOMPETENC IS NULL )
            AND ( TEL.NRCOMUNICAPARC = ( SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC
                                        WHERE NRORG         = PE.NRORG
                                            AND NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                            AND CDFORMACOMU   = 1 )
                    OR TEL.NRCOMUNICAPARC IS NULL )
            AND ( FAX.NRCOMUNICAPARC = ( SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC
                                        WHERE NRORG         = PE.NRORG
                                            AND NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                            AND CDFORMACOMU   = 10 )
                    OR FAX.NRCOMUNICAPARC IS NULL )
            AND ( EMA.NRCOMUNICAPARC = ( SELECT MAX(NRCOMUNICAPARC) FROM COMUNICAPARC
                                        WHERE NRORG         = PE.NRORG
                                            AND NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                            AND CDFORMACOMU   = 5 )
                    OR EMA.NRCOMUNICAPARC IS NULL )
SQL
);
        $sql->execute($params);
        return $sql->fetch();
    }

    public function montaSQLVinculoManad($params) {
        //var_dump('aqui montaSQLVinculoManad');

        $in_ds_inicio = $params['P_DS_INICIO'];
        $in_ds_fim = is_null($params['P_DS_FIM']) ? 'NULL' : $params['P_DS_FIM'];
        
        if($params['P_DSORDEM'] == 'ALFABETICA') {
            $in_ds_inicio = "'".$in_ds_inicio."'";
            $in_ds_fim = "'".$in_ds_fim."'";
        }
        
        //var_dump('$params', $params); //die;
                        
$sql = <<<SQL
    SELECT
        VM.NRPESSOA
    FROM
            GPE_VINCULOM VM
        JOIN GPE_VINCULOH VH 
            ON VH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                        FROM (SELECT VHH.DTMESCOMPETENC
                                                FROM GPE_VINCULOH VHH
                                                WHERE VHH.DTMESCOMPETENC BETWEEN :P_PRIMEIRODIAANO AND :P_DTULTDIAMES
                                                AND VHH.NRORG = VH.NRORG
                                                AND VHH.NRVINCULOM = VH.NRVINCULOM
                                                AND (   (:P_DSORDEM = 'ALFABETICA')
                                                    OR (:P_DSORDEM = 'MATRICULA')
                                                    OR (:P_DSORDEM = 'DATA_ADMISSAO')
                                                    OR (:P_DSORDEM = 'LISTA_VINCULO')
                                                    OR (:P_DSORDEM = 'ESTRUTURA'
                                                                AND (VHH.NRESTRUTLEGAL = :P_DS_INICIO)
                                                            
                                                                AND (VHH.NRESTRUTGEREN = :P_DS_FIM
                                                                    OR :P_DS_FIM IS NULL)
                                                            )
                                                    OR   (:P_DSORDEM = 'LISTA_ESTRUTURA'
                                                                AND (VHH.NRESTRUTLEGAL IN ($in_ds_inicio))
                                                            
                                                                AND (VHH.NRESTRUTGEREN IN ($in_ds_fim)
                                                                    OR :P_DS_FIM IS NULL)
                                                            )
                                                    OR   (:P_DSORDEM = 'LISTA_NRESTRUTSIND'
                                                                AND (VHH.NRESTRUTLEGAL IN ($in_ds_inicio))
                                                            
                                                                AND (VHH.NRESTRUTSIND IN ($in_ds_fim))
                                                            )
                                                    )
                                            ORDER BY VHH.DTMESCOMPETENC DESC)
                                WHERE ROWNUM = 1)
        AND VH.NRVINCULOM = VM.NRVINCULOM
        AND VH.NRORG = VM.NRORG
    WHERE
            VM.NRORG = :P_NRORG
        AND ( VM.DTRESCISAOVINC IS NULL
            OR VM.DTRESCISAOVINC >  :P_PRIMEIRODIAANO )
        AND ( ( VM.DTADMISSAOVINC <> VM.DTRESCISAOVINC )
            OR VM.DTRESCISAOVINC IS NULL )
        AND VM.DTADMISSAOVINC <= :P_DTULTDIAMES
        
        AND (     (:P_DSORDEM = 'ALFABETICA'
                        AND TRIM(UPPER(VM.NMVINCULOM)) BETWEEN :P_DS_INICIO AND :P_DS_FIM
                )
            OR (:P_DSORDEM = 'MATRICULA'
                        AND VM.CDMATRICULA BETWEEN :P_DS_INICIO AND :P_DS_FIM
                )
            OR (:P_DSORDEM = 'DATA_ADMISSAO'
                        AND VM.DTADMISSAOVINC BETWEEN :P_DS_INICIO AND :P_DS_FIM
                )
            OR (:P_DSORDEM = 'ESTRUTURA'
                        AND (VH.NRESTRUTLEGAL = :P_DS_INICIO)
                    
                        AND (VH.NRESTRUTGEREN = :P_DS_FIM
                            OR :P_DS_FIM IS NULL)
                )
            OR (:P_DSORDEM = 'LISTA_ESTRUTURA'
                        AND (VH.NRESTRUTLEGAL IN ($in_ds_inicio))
                    
                        AND (VH.NRESTRUTGEREN IN ($in_ds_fim)
                            OR :P_DS_FIM IS NULL)
                )
            OR (:P_DSORDEM = 'LISTA_NRESTRUTSIND'
                        AND (VH.NRESTRUTLEGAL IN ($in_ds_inicio))
                    
                        AND (VH.NRESTRUTSIND IN ($in_ds_fim))
                )
            OR (:P_DSORDEM = 'LISTA_VINCULO'
                        AND VM.NRVINCULOM IN ($in_ds_inicio)
                )
            )
    ORDER BY
        VM.NMVINCULOM
SQL;
        $result = $this->entityManager->getConnection()->prepare($sql);
        $result->execute($params);

        return $result->fetchAll();
    }

    public function get_dataPessoa($params){
        $sql = $this->entityManager->getConnection()->prepare(<<<SQL
             SELECT PH.NRPESSOA,
                    VM.NRVINCULOM,           
                    VM.NMVINCULOM,
                    PH.NRCPFPESSOA,
                    VM.DTADMISSAOVINC,
                    VH.NRESTRUTLEGAL
                FROM GPE_VINCULOM VM
            INNER JOIN GPE_VINCULOH VH 
                    ON VH.NRVINCULOM     = VM.NRVINCULOM
                AND VH.NRORG          = VM.NRORG
                AND VH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                            FROM (SELECT VHH.DTMESCOMPETENC
                                                    FROM GPE_VINCULOH VHH
                                                    WHERE VHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                    AND VHH.NRORG = VH.NRORG
                                                    AND VHH.NRVINCULOM = VH.NRVINCULOM
                                                ORDER BY VHH.DTMESCOMPETENC DESC)
                                            WHERE ROWNUM = 1)
            INNER JOIN GPE_PESSOA PM
                    ON PM.NRPESSOA       = VM.NRPESSOA
                AND PM.NRORG          = VM.NRORG
            INNER JOIN GPE_PESSOAH PH
                    ON PH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                            FROM (SELECT PHH.DTMESCOMPETENC
                                                    FROM GPE_PESSOAH PHH
                                                    WHERE PHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                    AND PH.NRORG = PHH.NRORG
                                                    AND PH.NRPESSOA = PHH.NRPESSOA
                                                ORDER BY PHH.DTMESCOMPETENC DESC)
                                            WHERE ROWNUM = 1)
                AND PH.NRORG    = PM.NRORG
                AND PH.NRPESSOA = PM.NRPESSOA
                WHERE VM.NRORG = :P_NRORG
                AND VM.NRPESSOA = :P_NRPESSOA
SQL
);
        $sql->execute($params);
        return $sql->fetch();
    }

    public function get_regK050($params){
        $sql = $this->entityManager->getConnection()->prepare(<<<SQL
             SELECT VM.NRVINCULOM,
                    SUBSTR(VM.NMVINCULOM, 1, 255) NMVINCULOM,
                    TO_CHAR(VM.DTADMISSAOVINC, 'DDMMYYYY') DTADMISSAOVINC,
                    TO_CHAR(VM.DTRESCISAOVINC, 'DDMMYYYY') DTRESCISAOVINC,
                    VM.NRVINCULOEMPREG,
                    SUBSTR(REPLACE(REPLACE(PH.NRCPFPESSOA,'.',''),'-',''), 1, 11) NRCPFPESSOA,
                    SUBSTR(REPLACE(REPLACE(PH.NRPISPASEPPES,'.',''),'-',''), 1, 11) NRPISPASEPPES,
                    TO_CHAR(PH.DTNASCPESSOA, 'DDMMYYYY') DTNASCPESSOA,
                    SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT, '.', ''), '/', ''), '-', ''), 1, 14) CDCNPJEST,
                    SUBSTR(REPLACE(REPLACE(EH.CDCEIESTRUT,'.',''),'-',''), 1, 12) CDCEIEST,
                    VE.CODCATEGTRAB
               FROM GPE_VINCULOM VM
         INNER JOIN GPE_VINCULOH VH 
                 ON VH.NRVINCULOM     = VM.NRVINCULOM
                AND VH.NRORG          = VM.NRORG
                AND VH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                           FROM (SELECT VHH.DTMESCOMPETENC
                                                   FROM GPE_VINCULOH VHH
                                                  WHERE VHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                    AND VHH.NRORG = VH.NRORG
                                                    AND VHH.NRVINCULOM = VH.NRVINCULOM
                                               ORDER BY VHH.DTMESCOMPETENC DESC)
                                         WHERE ROWNUM = 1)
         INNER JOIN GPE_PESSOA PM
                 ON PM.NRPESSOA       = VM.NRPESSOA
                AND PM.NRORG          = VM.NRORG
         INNER JOIN GPE_PESSOAH PH
                 ON PH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                           FROM (SELECT PHH.DTMESCOMPETENC
                                                   FROM GPE_PESSOAH PHH
                                                  WHERE PHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                    AND PH.NRORG = PHH.NRORG
                                                    AND PH.NRPESSOA = PHH.NRPESSOA
                                               ORDER BY PHH.DTMESCOMPETENC DESC)
                                         WHERE ROWNUM = 1)
                AND PH.NRORG    = PM.NRORG
                AND PH.NRPESSOA = PM.NRPESSOA
         INNER JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                 AND EH.NRORG = VH.NRORG
                                 AND EH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                                            FROM (SELECT DTMESCOMPETENC
                                                                    FROM ESTRUTURAH H1
                                                                   WHERE H1.NRORG = EH.NRORG
                                                                     AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                                     AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                ORDER BY DTMESCOMPETENC DESC)
                                                          WHERE ROWNUM = 1)
         INNER JOIN GPE_VINCULOEMPREG VE
                 ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
              WHERE VM.NRORG = :P_NRORG
                AND VM.NRPESSOA = :P_NRPESSOA
SQL
);
        $sql->execute($params);
        return $sql->fetch();
    }

    public function get_regK100($params){
        $sql = $this->entityManager->getConnection()->prepare(<<<SQL
             SELECT TO_CHAR(EM.DTINIVIGENCIA, 'DDMMYYYY') DTINIVIGENCIA,
                    EM.NRESTRUTURAM,
                    SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT, '.', ''), '/', ''), '-', ''), 1, 14) CDCNPJEST,
                    SUBSTR(REPLACE(REPLACE(EH.CDCEIESTRUT,'.',''),'-',''), 1, 12) CDCEIEST,
                    SUBSTR(EH.NMRAZSOCESTRUT, 1, 255) NMRAZSOCESTRUT,
                    SUBSTR(REPLACE(REPLACE(REPLACE(EHSUP.CDCNPJESTRUT, '.', ''), '/', ''), '-', ''), 1, 14) CDCNPJTOM,
                    SUBSTR(REPLACE(REPLACE(EHSUP.CDCEIESTRUT,'.',''),'-',''), 1, 12) CDCEITOM
                FROM GPE_VINCULOM VM
                JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                                    AND VH.NRVINCULOM = VM.NRVINCULOM
                                    AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                                FROM GPE_VINCULOH H1
                                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                                AND H1.NRORG = VH.NRORG
                                                                AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                /*Estabelecimento/Lotacao*/
                JOIN ESTRUTURAM EM ON EM.NRORG = VH.NRORG
                                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
                LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                            FROM ESTRUTURAH H1
                                                            WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                                AND H1.NRORG = EH.NRORG
                                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                JOIN PARCNEGOCIO PN ON PN.NRORG = EM.NRORG
                                    AND PN.NRPARCNEGOCIO = EM.NRPARCNEGOCIO
                /*Estabelecimento/Lotacao - Tomador superior da estrutura gerencial*/
                LEFT JOIN TIPOHIERARQORG TH ON (TH.NRORG = EM.NRORG OR TH.NRORG = 0)
                                            AND TH.NRTIPOESTRUTREL = :P_NRTIPOESTRUTGEREN
                                            AND TH.NRTIPOESTRUTSUP = NVL(:P_NRTIPOESTRUTOMADOR, 7)
                LEFT JOIN HIERARQUIAORG HO ON HO.NRORG = EM.NRORG
                                            AND HO.NRTIPOHIERARQORG = TH.NRTIPOHIERARQORG
                                            AND HO.NRESTRUTURAMREL = VH.NRESTRUTGEREN
                                            AND HO.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                                            AND (HO.DTFIMVIGENCIA IS NULL OR HO.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
                                            AND HO.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA)
                                                                    FROM HIERARQUIAORG HI
                                                                    WHERE HI.NRORG = HO.NRORG
                                                                    AND HI.NRESTRUTURAMREL = HO.NRESTRUTURAMREL
                                                                    AND NRTIPOHIERARQORG = HO.NRTIPOHIERARQORG
                                                                    AND HI.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                                                                    AND (HI.DTFIMVIGENCIA IS NULL OR HI.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
                                                                    AND EM.DTINIVIGENCIA <= :P_DTMESCOMPETENC)
                LEFT JOIN ESTRUTURAM EMSUP ON EMSUP.NRESTRUTURAM = HO.NRESTRUTURAMSUP
                                            AND EMSUP.NRORG = HO.NRORG
                LEFT JOIN ESTRUTURAH EHSUP ON EHSUP.NRESTRUTURAM = EMSUP.NRESTRUTURAM
                                            AND EHSUP.NRORG = EMSUP.NRORG
                                            AND EHSUP.DTMESCOMPETENC = (SELECT MAX(EHHSUP.DTMESCOMPETENC)
                                                                        FROM ESTRUTURAH EHHSUP
                                                                        WHERE EHHSUP.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                        AND EHHSUP.NRESTRUTURAM = EH.NRESTRUTURAM
                                                                        AND EHHSUP.NRORG = EH.NRORG)
                /*Categoria Trabalhador*/
                JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
                JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
                WHERE VM.NRORG      = :P_NRORG
                AND VM.NRVINCULOM = :P_NRVINCULOM
SQL
);
        $sql->execute($params);
        return $sql->fetch();
    }

    public function get_regK150($params){
        //var_dump('aqui get_regK150');
        //var_dump('$params', $params); //die;

        $sql = $this->entityManager->getConnection()->prepare(<<<SQL
             SELECT FH.NREVENTOM,
                    SUBSTR(FH.NMEVENTOH, 1, 255) NMEVENTOH,
                    TO_CHAR(FH.DTULTATU, 'DDMMYYYY') DTULTATU,
                    TO_CHAR(FH.DTINCLUSAO, 'DDMMYYYY') DTINCLUSAO
                FROM FPA_EVENTOM FM
                JOIN FPA_EVENTOH FH  ON FH.NREVENTOM = FM.NREVENTOM
                                    AND FH.NRORG = FM.NRORG
                                    AND FH.DTMESCOMPETENC = (SELECT DTMESCOMPETENC
                                                            FROM (SELECT DTMESCOMPETENC
                                                                    FROM FPA_EVENTOH H1
                                                                    WHERE H1.NREVENTOM = FH.NREVENTOM
                                                                      AND H1.NRORG = FH.NRORG
                                                                      AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                ORDER BY H1.DTMESCOMPETENC DESC)
                                                            WHERE ROWNUM = 1)
                WHERE EXISTS (SELECT 1 
                                FROM FPA_ITECALCFOLHA F1
                            WHERE NRORG = :P_NRORG 
                                AND FM.NREVENTOM = F1.NREVENTOM 
                                AND F1.DTOCORRENCIA BETWEEN :P_DTPERIODINI AND :P_DTPERIODFIM)
SQL
);
        $sql->execute($params);
        return $sql->fetchAll();
    }
}

