<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;

class ParametroSindicatoService {
    protected $entityManager;
    protected $hcmParameters;
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
   public function replicaParametroSindicato($row, $nrestruturam, &$nmestruturam) {
        $sindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findBy(
            array('nrorg' => $row['NRORG'], 'nrestruturam' =>$nrestruturam));
        $estrutura = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->findBy(
            array('nrorg' => $row['NRORG'], 'nrestruturam' =>$nrestruturam));
        $nmestruturam=$estrutura[0]->getNmestruturam();
        
        if (count($sindicato)==0){
            $novaEstrutura['NRORG'] = $row['NRORG'];
            $novaEstrutura['NRESTRUTURAM'] = $nrestruturam;
            $novaEstrutura['IDATIVO'] = $row['IDATIVO'];
            $novaEstrutura['DTINICIOVIGENCIA'] = DateUtil::getDataDeString($row['DTINICIOVIGENCIA']);
            $novaEstrutura['DTFIMVIGENCIA'] = DateUtil::getDataDeString($row['DTFIMVIGENCIA']);
            $novaEstrutura['IDULTRANOANT13'] = $row['IDULTRANOANT13'];
            $novaEstrutura['IDULTRPERANTFER'] = $row['IDULTRPERANTFER'];
            $novaEstrutura['NRMESESMEDIA1'] = $row['NRMESESMEDIA1'];
            $novaEstrutura['NRMESESMEDIA2'] = $row['NRMESESMEDIA2'];
            $novaEstrutura['NRMESESMEDIA3'] = $row['NRMESESMEDIA3'];
            $novaEstrutura['CDSINDICAL'] = $row['CDSINDICAL'];
            $novaEstrutura['DTBASESINDICAL'] = DateUtil::getDataDeString($row['DTBASESINDICAL']);
            $novaEstrutura['NRDIV13ANTECIP'] = $row['NRDIV13ANTECIP'];
            $novaEstrutura['NRDIASAPURVALES'] = $row['NRDIASAPURVALES'];
            $novaEstrutura['VRPERDESCVALE'] = $row['VRPERDESCVALE'];
            
            $paramsindicato = $this->setParametroSindicato(
                $novaEstrutura['NRORG'], $novaEstrutura['NRESTRUTURAM'], $novaEstrutura['IDATIVO'], $novaEstrutura['IDULTRPERANTFER'], $novaEstrutura['DTINICIOVIGENCIA'], $novaEstrutura['DTFIMVIGENCIA'], 
                $novaEstrutura['IDULTRANOANT13'], $novaEstrutura['NRMESESMEDIA1'], $novaEstrutura['NRMESESMEDIA2'], $novaEstrutura['NRMESESMEDIA3'], $novaEstrutura['CDSINDICAL'], $novaEstrutura['DTBASESINDICAL'], 
                $novaEstrutura['NRDIV13ANTECIP'], $novaEstrutura['NRDIASAPURVALES'], $novaEstrutura['VRPERDESCVALE']
            );
            return true;            
        }
        return false;
   }
   
   public function setParametroSindicato($nrorg, $nrestruturam, $idativo, $idultrperantfer, $dtiniciovigencia, $dtfimvigencia, $idultranoant13, 
                                         $nrmesesmedia1, $nrmesesmedia2, $nrmesesmedia3, $cdsindical, $dtbasesindical, $nrdiv13antecip, $nrdiasapurvales, $vrperdescvale){
        $fpa_paramsidicato = Repositories::FPA_PARAMSINDICATO;
        
        $parametroSindicato = new $fpa_paramsidicato;
        $parametroSindicato->setNrorg($nrorg);
        $parametroSindicato->setNrestruturam($nrestruturam);
        $parametroSindicato->setIdativo($idativo);
        $parametroSindicato->setIdultrperantfer($idultrperantfer);
        $parametroSindicato->setDtiniciovigencia($dtiniciovigencia);
        $parametroSindicato->setDtfimvigencia($dtfimvigencia);
        $parametroSindicato->setIdultranoant13($idultranoant13);
        $parametroSindicato->setNrmesesmedia1($nrmesesmedia1);
        $parametroSindicato->setNrmesesmedia2($nrmesesmedia2);
        $parametroSindicato->setNrmesesmedia3($nrmesesmedia3);
        $parametroSindicato->setCdsindical($cdsindical);
        $parametroSindicato->setDtbasesindical($dtbasesindical);
        $parametroSindicato->setNrdiv13antecip($nrdiv13antecip);
        $parametroSindicato->setNrdiasapurvales($nrdiasapurvales);
        $parametroSindicato->setVrperdescvale($vrperdescvale);
        $parametroSindicato->setNrsindicato(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgPadrao(), 'FPA_PARAMSINDICATO', 1, 12, true));
        
        $this->entityManager->persist($parametroSindicato);
        $this->entityManager->flush();
        
        return $parametroSindicato;
    }
    
}