<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;

class TipoFeriasService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function deleteTipoFerias($dataset) {
        try {
            $this->entityManager->beginTransaction();
            $tipoferiash = $this->entityManager->getRepository(Repositories::FPA_TIPOFERIASH)->findOneBy(array("nrtipoferias" => $dataset['NRTIPOFERIAS'], "nrtipoferiash" => $dataset['NRTIPOFERIASH']));
            $this->entityManager->remove($tipoferiash);
            $this->entityManager->flush();
            $tipoferiashh = $this->entityManager->getRepository(Repositories::FPA_TIPOFERIASH)->findOneBy(array("nrtipoferias" => $dataset['NRTIPOFERIAS']));
            if(empty($tipoferiashh)) {
                $tipoferiasm = $this->entityManager->getRepository(Repositories::FPA_TIPOFERIASM)->findOneBy(array("nrtipoferias" => $dataset['NRTIPOFERIAS'],"nrorg" => $dataset['NRORG']));
                $this->entityManager->remove($tipoferiasm);
                $this->entityManager->flush();
            }
            $this->entityManager->commit();
        } catch (\Exception $e) {            
            $this->entityManager->rollback();
            throw $e;
        }
    }
}