<?php
namespace HCM\Geral\Repository\Esocial;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class S2206Repository {

    protected  $connection;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function getItensParaEnvioS2206($params) {
        try {
            $sql = <<<SQL
SELECT VH.NRVINCULOM as NRCHAVE,
       VH.NRVINCULOM,
       GREATEST(NVL(SL.DTALTESALARIO, '01/01/1000'), NVL(AE.DTINIESCALA, '01/01/1000'), NVL(MOV.DTINIMOVIMENT, '01/01/1000'), NVL(VM.DTESOCIAL, '01/01/1000'), NVL(AO.DTINIOCUPACAO, '01/01/1000')) as DTMESCOMPETENC,
       SL.DTALTESALARIO,AE.DTINIESCALA,MOV.DTINIMOVIMENT,VM.DTESOCIAL,
       'A' as IDOPERACAO
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'MONTH'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)                                                 
  LEFT JOIN GPE_ALTESALARIO SL ON SL.NRVINCULOM = VM.NRVINCULOM
                              AND SL.NRORG = VM.NRORG
                              AND SL.DTALTESALARIO = (SELECT MAX(SLL.DTALTESALARIO) FROM GPE_ALTESALARIO SLL
                                                     WHERE SLL.NRVINCULOM = SL.NRVINCULOM
                                                       AND SLL.NRORG = SL.NRORG
                                                       AND SLL.DTALTESALARIO <= LAST_DAY(:P_DTMESCOMPETENC))
                              AND SL.NROCORRENCIA =  (SELECT MAX(NROCORRENCIA) FROM GPE_ALTESALARIO
                                                       WHERE GPE_ALTESALARIO.DTALTESALARIO = SL.DTALTESALARIO
                                                         AND GPE_ALTESALARIO.NRVINCULOM = SL.NRVINCULOM
                                                         AND GPE_ALTESALARIO.NRORG = SL.NRORG)
  LEFT JOIN GPE_ALTEESCALA AE ON AE.NRORG = VH.NRORG
                             AND AE.NRVINCULOM = VH.NRVINCULOM
                             AND (AE.DTFIMESCALA IS NULL OR AE.DTFIMESCALA > :P_DTMESCOMPETENC)
                             AND AE.DTINIESCALA = (SELECT MAX(DTINIESCALA) FROM GPE_ALTEESCALA
                                                    WHERE GPE_ALTEESCALA.DTINIESCALA <= LAST_DAY(:P_DTMESCOMPETENC)
                                                      AND (GPE_ALTEESCALA.DTFIMESCALA IS NULL OR GPE_ALTEESCALA.DTFIMESCALA > LAST_DAY(:P_DTMESCOMPETENC))
                                                      AND GPE_ALTEESCALA.NRVINCULOM = AE.NRVINCULOM
                                                      AND GPE_ALTEESCALA.NRORG = AE.NRORG)
  LEFT JOIN GPE_ALTEOCUPACAO AO ON AO.NRORG = VH.NRORG
                                AND AO.NRVINCULOM = VH.NRVINCULOM
                                AND (AO.DTFIMOCUPACAO IS NULL OR AO.DTFIMOCUPACAO > :P_DTMESCOMPETENC)
                                AND AO.DTINIOCUPACAO = (SELECT MAX(DTINIOCUPACAO) FROM GPE_ALTEOCUPACAO
                                                         WHERE GPE_ALTEOCUPACAO.DTINIOCUPACAO <= LAST_DAY(:P_DTMESCOMPETENC)
                                                           AND (GPE_ALTEOCUPACAO.DTFIMOCUPACAO IS NULL OR GPE_ALTEOCUPACAO.DTFIMOCUPACAO > LAST_DAY(:P_DTMESCOMPETENC))
                                                           AND GPE_ALTEOCUPACAO.NRVINCULOM = AE.NRVINCULOM
                                                           AND GPE_ALTEOCUPACAO.NRORG = AE.NRORG)
  LEFT JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 8
                AND SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.'),'/'),'-'),1,8) = SUBSTR(REPLACE(REPLACE(REPLACE(:P_CDCNPJEMPREGADOR,'.'),'/'),'-'),1,8)
                AND MO.DTINIMOVIMENT <= LAST_DAY(:P_DTMESCOMPETENC)) MOV ON MOV.NRORG = VH.NRORG
                                                                                                   AND MOV.NRVINCULOM = VH.NRVINCULOM 
 WHERE VM.NRORG = :P_NRORG
   AND VH.NRESTRUTLEGAL = :P_NRESTRUTURAM
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= TRUNC(SYSDATE))
   AND VM.NRTIPOVINCULOM = 1 /*CLT*/
   AND (SL.DTALTESALARIO IS NOT NULL OR AE.DTINIESCALA IS NOT NULL OR
        MOV.DTINIMOVIMENT IS NOT NULL OR AO.DTINIOCUPACAO IS NOT NULL OR
        VM.DTESOCIAL BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC))                      
   AND (VM.NRVINCULOM = :P_NRVINCULOM OR :P_NRVINCULOM IS NULL)
   AND (GREATEST(NVL(SL.DTALTESALARIO, '01/01/1000'), NVL(AE.DTINIESCALA, '01/01/1000'), NVL(MOV.DTINIMOVIMENT, '01/01/1000'), NVL(VM.DTESOCIAL, '01/01/1000'), NVL(AO.DTINIOCUPACAO, '01/01/1000')) >= :P_DTREFNAOPERIOD OR :P_DTREFNAOPERIOD IS NULL)
 ORDER BY 1,3
SQL;
            $params = array(
                "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
                "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
                "P_NRTIPOESTRUTLEGAL" => $this->hcmParameters->getTipoEstruturaLegalOrg(),
                "P_CDCNPJEMPREGADOR" => isset($params['CDCNPJEMPREGADOR']) ? $params['CDCNPJEMPREGADOR'] : null,
                "P_NRESTRUTURAM" => isset($params['NRESTRUTURAM']) ? $params['NRESTRUTURAM'] : null,
                "P_NRTPAMBIENTE" => isset($params['NRTPAMBIENTE']) ? $params['NRTPAMBIENTE'] : null,
                "P_NRVINCULOM" => isset($params['NRVINCULOM']) ? $params['NRVINCULOM'] : null,
                "P_DTREFNAOPERIOD" => isset($params['DTREFNAOPERIOD']) ? $params['DTREFNAOPERIOD'] : null,
            );
            return $this->connection->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getDadosS2206($parametros) {
        try {
            $dataHistorico = \HCM\Util\DateUtil::getDataDeString($parametros['DTMESCOMPETENC'], \HCM\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA, true)->format("d/m/Y");
            
            /* Se for retificação do evento utiliza a data de envio do original para considerar as mesmas situações da época do primeiro envio */
            $dataEnvioOrig = null;
            if ($parametros['IDOPERACAO'] == 'R') {
                $dataEnvioOrig = $parametros['DTRESPOSTAORIG'];
            }
            
            $dados = $this->getDadosPrincipais($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRESTRUTURAM'], $dataHistorico);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getDadosPrincipais($nrenvio, $nrchave, $nrestruturam, $dtmescompetenc) {
        $sql = <<<SQL
/*getDadosS2206*/
SELECT VM.NRVINCULOM CHAVE,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') TPINSC,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END NRINSC,
       --ideVinculo
       REPLACE(REPLACE(PH.NRCPFPESSOA,'.'),'-') AS CPFTRAB,
       NVL(VH.CDMATRICULAESOCIAL, VM.NRVINCULOM) AS MATRICULA,
       --altContratual
       TO_CHAR(DECODE(VM.DTESOCIAL,TO_DATE(:P_DTHISTORICO),VM.DTESOCIAL,CASE WHEN TRUNC(SL.DTALTESALARIO,'MONTH') = TRUNC(TO_DATE(:P_DTHISTORICO),'MONTH') THEN SL.DTALTESALARIO ELSE VH.DTULTATU END), 'YYYY-MM-DD') AS DTALTERACAO,
       '' AS DTEF,
       '' AS DSCALT,
       --vinculo
       DECODE(CE.CDESOCIAL,'410',1,VH.NRTPREGIMEPREV) AS TPREGPREV,
       --infoRegimeTrab
       --infoCeletista
       '1' AS TPREGJOR,
       CASE WHEN VM.NRVINCULOEMPREG IN ('3','4','12','13') THEN '2' ELSE '1' END NATATIVIDADE,
       TO_CHAR(ES.DTBASESINDICAL, 'MM') AS DTBASE,
       REPLACE(REPLACE(ES.CDCNPJESTRUT, '.'), '/') AS CNPJSINDCATEGPROF,
       --trabTemp
       '' AS JUSTPRORR,
       --aprend
       '' AS APREND_TPINSC,
       '' AS APREND_NRINSC,
       --infoEstatutario
       '' AS TPPLANRP,
       --infoContrato
       VH.NRCARGO codCargo,
       VH.NRFUNCAO codFuncao,
       CH.NMOCUPACAOH nmCargo,
       CH.NRCBO CBOCargo,
       '' dtIngrCargo,
       FH.NMOCUPACAOH nmFuncao,
       FH.NRCBO CBOFuncao,
       '' acumCargo,
       CE.CDESOCIAL codCateg,
       --remuneracao
       --ROUND(SL.VRSALARIO, 2) AS VRSALFX,
       DECODE(SL.IDTPSALARIO,'HORA', ROUND(SL.VRSALARIO / (EH.QTHRESCALATRABH * 30), 2), ROUND(SL.VRSALARIO, 2)) vrSalFx,
       DECODE(SL.IDTPSALARIO,'HORA','1','DIARIO','2','SEMANAL','3','QUINZENAL','4','MENSAL','5','TAREFA','6','7') AS UNDSALFIXO,
       SUBSTR(SL.DSOBSERVACAO,1,90) AS DSCSALVAR,
       --duracao
       CASE WHEN VM.NRVINCULOEMPREG IN (9, 10, 11, 12, 13) THEN '2' ELSE '1' END tpContr,
       CASE WHEN VM.NRVINCULOEMPREG IN (9, 10, 11, 12, 13) THEN TO_CHAR(VH.DTFIMCONTRDETERMIN,'YYYY-MM-DD') ELSE '' END dtTerm,
       '' objDet,
       --localTrabalho
       --localTrabGeral
       DECODE(CE.CDESOCIAL,'106',NULL,DECODE(PNEH.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')) AS LOCALTRABGERAL_TPINSC,
       DECODE(CE.CDESOCIAL,'106',NULL,PNEH.NRINSCRICAOPARC) AS LOCALTRABGERAL_NRINSC,
       DECODE(CE.CDESOCIAL,'106',NULL,PNEH.NMPRINCIPALPARC) AS DESCCOMP,
       --localTrabDom
       DECODE(CE.CDESOCIAL,'106',NVL(LGD.CDESOCIAL,'O'),NULL) localTrabDom_TpLograd,
       DECODE(CE.CDESOCIAL,'106',EPD.DSENDERECO,NULL) localTrabDom_DscLograd,
       DECODE(CE.CDESOCIAL,'106',EPD.NRIMOVELENDERECO,NULL) localTrabDom_NrLograd,
       DECODE(CE.CDESOCIAL,'106',SUBSTR(EPD.DSCOMPLEENDERECO, 0, 30),NULL) localTrabDom_Complemento,
       DECODE(CE.CDESOCIAL,'106',EPD.NMBAIRROENDERECO,NULL) localTrabDom_Bairro,
       DECODE(CE.CDESOCIAL,'106',REPLACE(REPLACE(REPLACE(EPD.NRCEPENDERECO,' '),'.'),'-'),NULL) localTrabDom_Cep,
       DECODE(CE.CDESOCIAL,'106',MPD.CDMUNICIBGE,NULL) localTrabDom_CodMunic,
       DECODE(CE.CDESOCIAL,'106',EPD.SGESTADO,NULL) localTrabDom_Uf,
       --horContratual
       EH.QTHRSEMESCTRABH qtdHrsSem,
       TJ.CDESOCIAL AS tpJornada,
       '0' tmpParc,
       NVL(EH.IDHORNOTURNO,'N') horNoturno,
       EH.NMESCALATRABH dscJorn,
       --alvaraJudicial
       '' AS NRPROCJUD,
       --observacoes
       --treiCap
       VM.NRORG, EH.NRESCALATRABM, AE.NRTURNO
  FROM GPE_VINCULOM VM
  /*Dados do Empregado - Vínculo*/
  JOIN GPE_VINCULOH VH
    ON VH.NRVINCULOM = VM.NRVINCULOM
   AND VH.NRORG      = VM.NRORG
   AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                             WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTHISTORICO
                               AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTHISTORICO),'YEAR'),-12)
                               AND GPE_VINCULOH.NRVINCULOM = VM.NRVINCULOM
                               AND GPE_VINCULOH.NRORG = VM.NRORG)
  JOIN GPE_VINCULOEMPREG VE 
    ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE 
    ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Dados do Empregado - Pessoa*/                               
  JOIN GPE_PESSOA PE
    ON PE.NRPESSOA = VM.NRPESSOA
   AND PE.NRORG    = VM.NRORG
  JOIN GPE_PESSOAH PH
    ON PH.NRPESSOA = PE.NRPESSOA
   AND PH.NRORG    = PE.NRORG
   AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                             WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTHISTORICO
                               AND GPE_PESSOAH.NRPESSOA = PE.NRPESSOA
                               AND GPE_PESSOAH.NRORG = PE.NRORG)
  JOIN PARCNEGOCIO PN
    ON PN.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
   AND PN.NRORG         = PE.NRORG
  /*Local de Trabalho*/
  JOIN ESTRUTURAH ETH ON ETH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND ETH.NRORG = VH.NRORG
                    AND ETH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = ETH.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = ETH.NRORG)
  JOIN PARCNEGOCIO PNEH ON PNEH.NRPARCNEGOCIO = ETH.NRPARCNEGOCIO
                     AND PNEH.NRORG = ETH.NRORG
  /*Tomador de Serviços*/
  LEFT JOIN TIPOHIERARQORG TH ON (TH.NRORG = VM.NRORG OR TH.NRORG = 0)
                             AND TH.NRTIPOESTRUTREL = :P_NRTIPOESTRUTGEREN
                             AND TH.NRTIPOESTRUTSUP = NVL(:P_NRTIPOESTRUTOMADOR, 7)
  LEFT JOIN HIERARQUIAORG HO ON HO.NRORG = VM.NRORG
                            AND HO.NRTIPOHIERARQORG = TH.NRTIPOHIERARQORG
                            AND HO.NRESTRUTURAMREL = VH.NRESTRUTGEREN
                            AND HO.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                            AND (HO.DTFIMVIGENCIA IS NULL OR HO.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
                            AND HO.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA)
                                                      FROM HIERARQUIAORG HI
                                                     WHERE HI.NRORG = HO.NRORG
                                                       AND HI.NRESTRUTURAMREL = HO.NRESTRUTURAMREL
                                                       AND HI.NRTIPOHIERARQORG = HO.NRTIPOHIERARQORG
                                                       AND HI.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                                                       AND (HI.DTFIMVIGENCIA IS NULL OR HI.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
                                                       AND HI.DTINIVIGENCIA <= :P_DTMESCOMPETENC)
                            AND (HO.DTFIMVIGENCIA >= LAST_DAY(:P_DTMESCOMPETENC) OR HO.DTFIMVIGENCIA IS NULL)
  LEFT JOIN ESTRUTURAM EMT ON EMT.NRESTRUTURAM = HO.NRESTRUTURAMSUP
                          AND EMT.NRORG = HO.NRORG
  LEFT JOIN ESTRUTURAH EHT ON EHT.NRESTRUTURAM = EMT.NRESTRUTURAM
                          AND EHT.NRORG = EMT.NRORG
                          AND EHT.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                     WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       AND ESTRUTURAH.NRESTRUTURAM = EHT.NRESTRUTURAM
                                                       AND ESTRUTURAH.NRORG = EHT.NRORG)
  LEFT JOIN PARCNEGOCIO PNT ON PNT.NRPARCNEGOCIO = EHT.NRPARCNEGOCIO
                           AND PNT.NRORG = EHT.NRORG
  /*Endereço Trabalho Domestico*/
  LEFT JOIN ENDERECOPARC EPD ON EPD.NRPARCNEGOCIO = NVL(PNT.NRPARCNEGOCIO,PNEH.NRPARCNEGOCIO)
                            AND EPD.NRORG = NVL(PNT.NRORG,PNEH.NRORG)
                            AND EPD.CDTIPOENDERECO = 'PRINCIPAL'
  LEFT JOIN MUNICIPIO MPD ON MPD.CDPAIS = EPD.CDPAIS
                         AND MPD.SGESTADO = EPD.SGESTADO
                         AND MPD.CDMUNICIPIO = EPD.CDMUNICIPIO
  LEFT JOIN LOGRADOURO LGD ON LGD.CDLOGRADOURO = EPD.CDLOGRADOURO
                         AND (LGD.NRORG = EPD.NRORG OR LGD.NRORG = 0)
  /*Cargo*/
  LEFT JOIN GPE_OCUPACAOH CH ON CH.NROCUPACAOM = VH.NRCARGO
                            AND CH.NRORG = VH.NRORG
                            AND CH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                      WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= LAST_DAY(:P_DTMESCOMPETENC)
                                                        AND GPE_OCUPACAOH.NROCUPACAOM = CH.NROCUPACAOM
                                                        AND GPE_OCUPACAOH.NRORG = CH.NRORG)
  /*Função*/
  LEFT JOIN GPE_OCUPACAOH FH ON FH.NROCUPACAOM = VH.NRFUNCAO
                            AND FH.NRORG = VH.NRORG
                            AND FH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                      WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= LAST_DAY(:P_DTMESCOMPETENC)
                                                        AND GPE_OCUPACAOH.NROCUPACAOM = FH.NROCUPACAOM
                                                        AND GPE_OCUPACAOH.NRORG = FH.NRORG)
  /*Salário*/
  LEFT JOIN GPE_ALTESALARIO SL ON SL.NRVINCULOM = VM.NRVINCULOM
                              AND SL.NRORG = VM.NRORG
                              AND SL.DTALTESALARIO = (SELECT MAX(DTALTESALARIO) FROM GPE_ALTESALARIO
                                                       WHERE GPE_ALTESALARIO.DTALTESALARIO <= LAST_DAY(:P_DTMESCOMPETENC)
                                                         AND GPE_ALTESALARIO.NRVINCULOM = SL.NRVINCULOM
                                                         AND GPE_ALTESALARIO.NRORG = SL.NRORG)
                              AND SL.NROCORRENCIA =  (SELECT MAX(NROCORRENCIA) FROM GPE_ALTESALARIO
                                                       WHERE GPE_ALTESALARIO.DTALTESALARIO = SL.DTALTESALARIO
                                                         AND GPE_ALTESALARIO.NRVINCULOM = SL.NRVINCULOM
                                                         AND GPE_ALTESALARIO.NRORG = SL.NRORG)
  /*Horário*/
  LEFT JOIN GPE_ALTEESCALA AE ON AE.NRORG = VH.NRORG
                             AND AE.NRVINCULOM = VH.NRVINCULOM
                             AND (AE.DTFIMESCALA IS NULL OR AE.DTFIMESCALA > LAST_DAY(:P_DTMESCOMPETENC) OR VM.DTRESCISAOVINC IS NOT NULL)
                             AND AE.DTINIESCALA = (SELECT MAX(DTINIESCALA) FROM GPE_ALTEESCALA
                                                    WHERE GPE_ALTEESCALA.DTINIESCALA <= LAST_DAY(:P_DTMESCOMPETENC)
                                                      AND (GPE_ALTEESCALA.DTFIMESCALA IS NULL OR GPE_ALTEESCALA.DTFIMESCALA > LAST_DAY(:P_DTMESCOMPETENC) OR VM.DTRESCISAOVINC IS NOT NULL)
                                                      AND GPE_ALTEESCALA.NRVINCULOM = AE.NRVINCULOM
                                                      AND GPE_ALTEESCALA.NRORG = AE.NRORG)
  LEFT JOIN GPE_ESCALATRABH EH ON EH.NRESCALATRABM = AE.NRESCALATRABM
                              AND EH.NRORG = AE.NRORG
                              AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_ESCALATRABH
                                                        WHERE GPE_ESCALATRABH.DTMESCOMPETENC <= LAST_DAY(:P_DTMESCOMPETENC)
                                                          AND GPE_ESCALATRABH.NRESCALATRABM = EH.NRESCALATRABM
                                                          AND GPE_ESCALATRABH.NRORG = EH.NRORG)
  LEFT JOIN PTO_TIPOJORNADA TJ ON TJ.NRTPJORNADA = EH.NRTPJORNADA
                              AND (TJ.NRORG = EH.NRORG OR TJ.NRORG = 0)
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND ESTRUTURAH.NRESTRUTURAM = EMH.NRESTRUTURAM
                                                 AND ESTRUTURAH.NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
  /*Sindicato*/
  LEFT JOIN ESTRUTURAH ES ON ES.NRESTRUTURAM = VH.NRESTRUTSIND
                         AND ES.NRORG = VH.NRORG
                         AND ES.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                   WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                     AND ESTRUTURAH.NRESTRUTURAM = ES.NRESTRUTURAM
                                                     AND ESTRUTURAH.NRORG = ES.NRORG)                        
 WHERE VM.NRORG = :P_NRORG
   AND VM.NRVINCULOM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTIPOESTRUTGEREN" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
            "P_NRTIPOESTRUTOMADOR" => $this->hcmParameters->getTipoEstruturaTomadorOrg(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_DTHISTORICO" => $dtmescompetenc,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

}