<?php
/**
 * Created by PhpStorm.
 * User: leonardocarvalho
 * Date: 01/03/2016
 * Time: 11:14
 */

namespace HCM\VAB\Services;

use HCM\Util\HCMParameters;
use Folha\Logic\ValesBeneficios\CalculoValeTransporte\Calculo;
use Folha\Entities\FpaTipomoviment;
use HCM\FPA\Controllers\LogRetrocessoCalculoController;

class CalculoValeTransporteService {

    protected $hcmParameters;

    public function __construct(HCMParameters $hcmParameters, LogRetrocessoCalculoController $logRetrocessoCalculoController) {
        $this->hcmParameters = $hcmParameters;
        $this->logRetrocessoCalculoController = $logRetrocessoCalculoController;
    }

    public function calcular(&$response, $idMemoria, $dsordem, $dsiniciovale, $dsfimvale, $dtiniciovale, $dtfinalvale, $dtpagamento, $nrtipolinhavinc, $dtmescompetenc, $nrorg, $row) {
        try {
            $info = new Calculo($response, $idMemoria, $dsiniciovale, $dsfimvale, $dtiniciovale, $dtfinalvale, $dtpagamento, $nrorg, $dtmescompetenc, $dsordem, $nrtipolinhavinc, $this->hcmParameters, $row);
            $info->calculo();
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function verificaQtdRetrocessoVale($dsordem, $dsiniciovale, $dsfimvale, $nrtipolinhavinc, $dtmescompetenc, $nrorg, $row) {
        try {
            $nrcalculofolha = $this->hcmParameters->determinaNrCalculoFolha(FpaTipomoviment::TP_MOV_VALE_TRANSPORTE);
            return $retrocesso = Calculo::verificaQtdRetrocesso($nrcalculofolha, $dtmescompetenc, $nrorg, $dsiniciovale, $dsfimvale, $dsordem, $nrtipolinhavinc, $row);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function retroceder($dsordem, $dsiniciovale, $dsfimvale, $nrtipolinhavinc, $dtmescompetenc, $nrorg, $row) {
        try {
            $nrcalculofolha = $this->hcmParameters->determinaNrCalculoFolha(FpaTipomoviment::TP_MOV_VALE_TRANSPORTE);
            Calculo::retroceder($nrcalculofolha, $dtmescompetenc, $nrorg, $dsiniciovale, $dsfimvale, $dsordem, $nrtipolinhavinc, $row);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function persistirLogRetrocesso($row){
        $row['DSORDEM'] = $row['DSORDEMVALE'];
        $row['DSINICIO'] = $row['DSINICIOVALE'];
        $row['DSFIM'] = $row['DSFIMVALE'];
        $this->logRetrocessoCalculoController->persistirLogRetrocesso('CALC_VT', $row);
    }

}