<?php
namespace HCM\VAB\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;

class TipoBeneficioService {
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function novo($dstpbeneficio)
    {
        $tpbeneficio = Repositories::TPBENEFICIO;
        
        $novo = new $tpbeneficio;
        $novo->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $novo->setDstpbeneficio($dstpbeneficio);
        $novo->setIdativo('S');  
        $novo->setDtinclusao(DateUtil::getDataAtual()); 
        $novo->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $novo->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $novo->setDtultatu(DateUtil::getDataAtual());
        $novo->setCdoperultatu($this->hcmParameters->getCdoperador());
        $novo->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        
        $novo->setNrtpbeneficio(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'TPBENEFICIO', 1, 12, true));
        
        $this->entityManager->persist($novo);
        $this->entityManager->flush();
        
        return $novo;
    }
    
}  