-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     22/03/2023  09:00                        
--   Issue:          416547 Criação Tela + abas "Lançamentos", "Estrutura" e "Ocupação"
-- ============================================================
-- ============================================================
-- Table: FPA_RATEIO
-- ============================================================
CREATE TABLE FPA_RATEIO
(
    NRORG                      NUMBER          NOT NULL,
    NRRATEIO                   NUMBER          NOT NULL,
    NRESTRUTURAM               NUMBER          NOT NULL,
    NREVENTOM                  NUMBER          NOT NULL,
    VRTAXA1                    FLOAT               NULL,
    DSREGRA1                   VARCHAR2(100)       NULL,
    DSOPERACAO1                VARCHAR2(10)         NULL,
    VRTAXA2                    FLOAT               NULL,
    DSREGRA2                   VARCHAR2(100)       NULL,
    DSOPERACAO2                VARCHAR2(10)         NULL,
    VRTAXA3                    FLOAT               NULL,
    DSREGRA3                   VARCHAR2(100)       NULL,
    DSOPERACAO3                VARCHAR2(10)         NULL,
    IDNGERARATEIOFALTA       VARCHAR2(1)     DEFAULT 'S' NOT NULL,
    CONSTRAINT CKC_IDNGERARATEIOFALTA_RAT CHECK (IDNGERARATEIOFALTA IN ('N','S')),
    IDNGERARATEIOATEST    VARCHAR2(1)     DEFAULT 'S' NOT NULL,
    CONSTRAINT CKC_IDNGERARATEIOATEST_RAT CHECK (IDNGERARATEIOATEST IN ('N','S')),
    DTINIVIGENCIA              DATE            NOT NULL,
    DTFIMVIGENCIA              DATE            NULL,
    IDATIVO                    VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_RAT CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_FPA_RATEIO  PRIMARY KEY (NRORG, NRRATEIO),
    CONSTRAINT FK_RATESTRUT FOREIGN KEY (NRORG, NRESTRUTURAM) REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM),
    CONSTRAINT FK_FPA_EVENTOM_ FOREIGN KEY (NREVENTOM) REFERENCES FPA_EVENTOM (NREVENTOM)
)
/

-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     22/03/2023  09:00                        
--   Issue:          416547 Criação Tela + abas "Lançamentos", "Estrutura" e "Ocupação"
-- ============================================================
-- ============================================================
-- Table: FPA_RATEIOLANC
-- ============================================================
CREATE TABLE FPA_RATEIOLANC
(
    NRORG                 NUMBER          NOT NULL,
    NRRATEIOLANC          NUMBER          NOT NULL,
    NRRATEIO              NUMBER          NOT NULL,
    DTLANCAMENTO          DATE                NULL,
    VRLANCAMENTO          FLOAT               NULL,
    VRACRESCIMO           FLOAT               NULL,
    VRDESCONTO            FLOAT               NULL,
    VRSUBTOTAL1           FLOAT               NULL,
    VRSUBTOTAL2           FLOAT               NULL,
    VRSUBTOTAL3           FLOAT               NULL,
    VRFINAL               FLOAT               NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_RATLANC CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_FPA_NRRATEIOLANC  PRIMARY KEY (NRORG, NRRATEIOLANC),
    CONSTRAINT FK_RATLANC_NRRATEIO FOREIGN KEY (NRORG, NRRATEIO) REFERENCES FPA_RATEIO (NRORG, NRRATEIO)
)
/

-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     22/03/2023  09:00                        
--   Issue:          416547 Criação Tela + abas "Lançamentos", "Estrutura" e "Ocupação"
-- ============================================================
-- ============================================================
-- Table: FPA_RATEIOESTRUT
-- ============================================================
CREATE TABLE FPA_RATEIOESTRUT
(
    NRORG                 NUMBER          NOT NULL,
    NRRATEIO              NUMBER          NOT NULL,
    NRRATEIOESTRUT        NUMBER          NOT NULL,
    NRESTRUTURAM          NUMBER          NOT NULL, 
    NRPESO                NUMBER              NULL,
    VRPORCENTAGEM         FLOAT               NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_RATESTRUT CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_FPA_NRRATEIOESTRUT  PRIMARY KEY (NRORG, NRRATEIOESTRUT),
    CONSTRAINT FK_RATESTRUT_NRRATEIO FOREIGN KEY (NRORG, NRRATEIO) REFERENCES FPA_RATEIO (NRORG, NRRATEIO),
    CONSTRAINT FK_RATESTRUT_ESTRUT FOREIGN KEY (NRORG, NRESTRUTURAM) REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM)
)
/

-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     22/03/2023  09:00                        
--   Issue:          416547 Criação Tela + abas "Lançamentos", "Estrutura" e "Ocupação"
-- ============================================================
-- ============================================================
-- Table: FPA_RATEIOOCUP 
-- ============================================================
CREATE TABLE FPA_RATEIOOCUP
(
    NRORG                 NUMBER          NOT NULL,
    NRRATEIO              NUMBER          NOT NULL,
    NRRATEIOOCUP          NUMBER          NOT NULL,
    NROCUPACAOM           NUMBER          NOT NULL, 
    NRPESO                NUMBER              NULL,
    VRPORCENTAGEM         FLOAT               NULL,
    NRESTRUTURAM          NUMBER              NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_ITRATOCUP CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_FPA_NRRATEIOOCUP  PRIMARY KEY (NRORG, NRRATEIOOCUP),
    CONSTRAINT FK_RATOCUP_NRRATEIO FOREIGN KEY (NRORG, NRRATEIO) REFERENCES FPA_RATEIO (NRORG, NRRATEIO),
    CONSTRAINT FK_RATOCUP_NROCUP FOREIGN KEY (NRORG, NROCUPACAOM) REFERENCES GPE_OCUPACAOM (NRORG, NROCUPACAOM),
    CONSTRAINT FK_RATOCUP_NRESTRUTURAM  FOREIGN KEY (NRORG, NRESTRUTURAM ) REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM)
)
/

/

-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     10/04/2023  09:00                        

--   Issue:          416548 - Rateio Diário de Gorjetas - Pobre Juan | Aba "Valores" + Cálculo do rateio
-- ============================================================
-- ============================================================
-- Table: FPA_RATEIOVAL
-- ============================================================
CREATE TABLE FPA_RATEIOVAL
(
    NRORG                 NUMBER          NOT NULL,
    NRRATEIO              NUMBER          NOT NULL,
    NRRATEIOVAL           NUMBER          NOT NULL,
    NRVINCULOM            NUMBER          NOT NULL, 
    VRVALOR               FLOAT               NULL,
    DTDIALANC             DATE                NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_RATVAL CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_FPA_NRRATEIOVAL  PRIMARY KEY (NRORG, NRRATEIOVAL),
    CONSTRAINT FK_RATVAL_NRRATEIO FOREIGN KEY (NRORG, NRRATEIO) REFERENCES FPA_RATEIO (NRORG, NRRATEIO),
    CONSTRAINT FK_RATVAL_NRVINC FOREIGN KEY (NRORG, NRVINCULOM) REFERENCES GPE_VINCULOM (NRORG, NRVINCULOM)
)
/