/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOOPERACROP                                            */
/* Tabela : TIPOOPERACROP                                                     */
/*                                                                            */
/* Criao:                                                                   */
/* 29/05/2007 - Pedro Nerino Viol de Lima                                     */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOOPERACROP
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOOPERACROP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPOR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.IDTPOPERACROP,0) <> NVL(:NEW.IDTPOPERACROP,0)) THEN
         :NEW.DTULTATUTPOR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOOPERACROP', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';IDENTRSAIDOP='||:OLD.IDENTRSAIDOP||
                               ';CDTIPOOPER='||:OLD.CDTIPOOPER||';IDTPOPERACROP='||:OLD.IDTPOPERACROP||';',SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOOPERACROP MODIFY DTULTATUTPOR DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPOOPERACROP','4.11.136'); END;
/

